<?php

namespace BusinessClass;

abstract class Question implements IResponseProcessingStrategy, IPrintQuestionStrategy
{
    private string $content;
    /**
     * @param string $content
     */
    public function __construct(string $content)
    {
        $this->content = $content;
    }

    public abstract function responseStrategy();

    public abstract function printStrategy(): string;

    /**
     * @return string
     */
    public function getContent(): string
    {
        return $this->content;
    }

    /**
     * @param string $content
     */
    public function setContent(string $content): void
    {
        $this->content = $content;
    }
}